
z=1920
Global jscrw=z
Global jscrh=z

Graphics 960,960,0,2
Graphics3D jscrw,jscrh,0,3

SeedRnd MilliSecs()

snow=LoadTexture("Drawn/snow.jpg",8)




snowb=LoadTexture("Drawn/snow.jpg",8)
ScaleTexture snowb,0.25,0.25
AntiAlias True

snowc=LoadTexture("Drawn/snowb.jpg",2+1)
ScaleTexture snowc,0.25,0.25

campivot=CreatePivot()
Cam=CreateCamera(campivot)
MoveEntity cam,0,0,300
PointEntity cam,campivot

inimg=LoadImage("Drawn/drawn.bmp")

RotateEntity campivot,75,0,0,0
TurnEntity campivot,0,0,45,1

lamp=CreateLight(2,campivot)
MoveEntity lamp,-150,150,240
LightRange lamp,240



sky=CreateSphere(32)
FlipMesh(sky)
ScaleMesh sky,400,400,400
EntityTexture sky,snowb
EntityColor sky,120,120,120


world=CreateMesh()

Global Render[100]

Global br[1024]


ground=CreateMesh(world)


For n=0 To 99
	d=Float(n)*2.5
	
;	br[n]		=CreateBrush(d,0,0)
;	br[n+100]	=CreateBrush(d,d/2,0)
;	br[n+200]	=CreateBrush(d,d,0)
;	br[n+300]	=CreateBrush(0,d,0)
;	br[n+400]	=CreateBrush(0,d/2,d)
;	br[n+500]	=CreateBrush(0,0,d)
;	br[n+600]	=CreateBrush(d/2,0,d)
;	br[n+700]	=CreateBrush(d,0,d/2)
;	br[n+800]	=CreateBrush(d/2,d/2,d/2)
	br[n+900]	=CreateBrush(d,d,d)
	BrushTexture br[n+900],snow
Next


intree=LoadImage("Drawn/tree.bmp")

ATree=CreateMesh()

For z=0 To 2
For x=0 To 15
For y=0 To 15
argb=ReadPixel(x+z*16,y,ImageBuffer(intree))
r=(argb And $00FF0000) Shr 16
g=(argb And $0000FF00) Shr 8
b=(argb And $000000FF)

If r<200
Plot3D(atree,x,z,16-y,br[999],r,g,b)
EndIf
Next
Next
Next

Global tree[5]

For t=0 To 3
tree[t]=CreateMesh()
For n=0 To 15
x=Rnd(-512,512)
z=Rnd(32,512)
PositionMesh atree,x,z,0
AddMesh atree,tree[t]
PositionMesh atree,-x,-z,0
Next

Next
FreeEntity atree




Snowpanes=CreateMesh()
Snowpane=CreateCube()
ScaleMesh(snowpane,1024,1,1024)
snowbrush=CreateBrush(255,255,255)
BrushTexture snowbrush,snowc
BrushShininess snowbrush,1
BrushBlend snowbrush,3
PaintMesh snowpane,snowbrush

PositionMesh snowpane,0,-63*4,0

For y=0 To 63 Step 8
	AddMesh snowpane,snowpanes
	RotateMesh snowpane,0,36,0
	PositionMesh snowpane,0,(16*4)-3.5,0
Next

ox=0
oy=0
LockBuffer ImageBuffer(inimg)
For layer=0 To 99
	Render[layer]=CreateMesh(world)
	
	For x=0 To 63
	For y=0 To 63
		argb=ReadPixelFast(ox+x,oy+y,ImageBuffer(inimg))
		
		r=(argb And $00FF0000) Shr 16
		g=(argb And $0000FF00) Shr 8
		b=(argb And $000000FF)
		d=1
		If r>250 And g<8 And b>250 Then d=0

r=r/16
g=g/16
b=b/16
r=r*16
g=g*16
b=b*16

		c=999
		If d=1 Then c=FindBrush(r,g,b)
		
		If d=1 Then Plot3D(Render[layer],x,0,Float((-y))+63.5,br[c],r,g,b)
	Next
	Next

	ox=ox+64
	If ox>=640 Then ox=0:oy=oy+64
	PositionMesh Render[layer],-64,(layer-64)*4,0
Next
UnlockBuffer ImageBuffer(inimg)



aspike=MakeSpike()
For l=0 To 4
spikelayer=CreateMesh(world)
For n=0 To 50
	fx#=Rnd(-256,256)
	fy#=Rnd(-256,256)
	fz#=Rnd(0,32)+(l*32)
	fr#=Rnd(-12,12)
	PositionMesh aspike,fx,fy,fz
	RotateMesh aspike,0,fr,fr
	AddMesh aspike,spikelayer
	RotateMesh aspike,0,-fr,-fr
	PositionMesh aspike,-fx,-fy,-fz
Next
EntityAlpha(spikelayer,0.4)
EntityShininess(spikelayer,3)
Next


w=128
h=128

For x=0 To w-1
For y=0 To h-1
	dz#=Rnd(-0.5,0.5)
	dx=(x-(w/2))*4
	dy=(y-(h/2))*4
	box=CreateCube()
	
	lit=980
	
	high=Rnd(2,3)
	For n=0 To 10
		If x<n Or y<n Or x>w-n Or y>h-n Then high=high+Rnd(2,5):lit=lit-(Rand(0,n))
	Next
	
	ScaleMesh box,2,2,high
	
	PaintMesh(box,br[lit+Rand(0,19)])
	PositionMesh box,dx,dy,dz

	;ScaleMesh box,1,1,3

	AddMesh box,Ground

	FreeEntity box
Next
Next

Repeat
Cls

RenderWorld()

;If KeyDown(200) Then MoveEntity campivot,0,0,-1
;If KeyDown(208) Then MoveEntity campivot,0,0,1
;
;If KeyDown(203) Then TurnEntity cam,0,-1,0,0
;If KeyDown(205) Then TurnEntity cam,0,1,0,0


If KeyDown(200) Then MoveEntity cam,0,0,1
If KeyDown(208) Then MoveEntity cam,0,0,-1

If KeyDown(203) Then TurnEntity cam,0,1,0
If KeyDown(205) Then TurnEntity cam,0,-1,0

If KeyDown(75) Then TurnEntity cam,0,1,0
If KeyDown(77) Then TurnEntity cam,0,-1,0

If KeyDown(71) Then TurnEntity cam,1,0,0
If KeyDown(73) Then TurnEntity cam,-1,0,0

If KeyDown(79) Then TurnEntity cam,0,0,1
If KeyDown(81) Then TurnEntity cam,0,0,-1


If KeyDown(17) Then MoveEntity cam,0,1,0
If KeyDown(31) Then MoveEntity cam,0,-1,0

If KeyDown(30) Then MoveEntity cam,-1,0,0
If KeyDown(32) Then MoveEntity cam,1,0,0



Delay 10

Flip
Until KeyDown(1)

SaveBuffer BackBuffer(),"out.bmp"


Function MakeSpike()
aspike=CreateMesh()
Plot3D(aspike,-4,-4,0,br[999])
Plot3D(aspike,-3,-3,0,br[999])
Plot3D(aspike,-2,-2,0,br[999])
Plot3D(aspike,-1,-1,0,br[999])

Plot3D(aspike,-4,3,0,br[999])
Plot3D(aspike,-3,2,0,br[999])
Plot3D(aspike,-2,1,0,br[999])
Plot3D(aspike,-1,0,0,br[999])

Plot3D(aspike,3,-4,0,br[999])
Plot3D(aspike,2,-3,0,br[999])
Plot3D(aspike,1,-2,0,br[999])
Plot3D(aspike,0,-1,0,br[999])

Plot3D(aspike,3,3,0,br[999])
Plot3D(aspike,2,2,0,br[999])
Plot3D(aspike,1,1,0,br[999])
Plot3D(aspike,0,0,0,br[999])

Plot3D(aspike,-3,-1,0,br[999])
Plot3D(aspike,-1,-3,0,br[999])

Plot3D(aspike,-3,0,0,br[999])
Plot3D(aspike,-1,2,0,br[999])

Plot3D(aspike,2,-1,0,br[999])
Plot3D(aspike,0,-3,0,br[999])

Plot3D(aspike,2,0,0,br[999])
Plot3D(aspike,0,2,0,br[999])

ScaleMesh aspike,0.25,0.25,0.25
RotateMesh aspike,90,0,0
RotateMesh aspike,0,0,45

EntityShininess aspike,0.8
;EntityAlpha aspike,0.5
;ScaleEntity aspike,0.25,0.25,0.25
Return aspike
End Function


Function FindBrush(fr,fg,fb)

c=-1
cr=500
cg=500
cb=500


thresh=0

For fn=0 To 99
	d#=Float(fn)*2.5
	
	
	If Abs(d-fr)<=cr+thresh And Abs(0-fg)<=cg+thresh And Abs(0-fb)<=cb+thresh Then 				cr=Abs(d-fr):cg=Abs(0-fg):cb=Abs(0-fb):c=fn
	If Abs(d-fr)<=cr+thresh And Abs((d/2)-fg)<=cg+thresh And Abs(0-fb)<=cb+thresh Then 			cr=Abs(d-fr):cg=Abs((d/2)-fg):cb=Abs(0-fb):c=fn+100
	If Abs(d-fr)<=cr+thresh And Abs(d-fg)<=cg+thresh And Abs(0-fb)<=cb+thresh Then 				cr=Abs(d-fr):cg=Abs(d-fg):cb=Abs(0-fb):c=fn+200
	If Abs(0-fr)<=cr+thresh And Abs(d-fg)<=cg+thresh And Abs(0-fb)<=cb+thresh Then 				cr=Abs(0-fr):cg=Abs(d-fg):cb=Abs(0-fb):c=fn+300
	If Abs(0-fr)<=cr+thresh And Abs((d/2)-fg)<=cg+thresh And Abs(d-fb)<=cb+thresh Then 			cr=Abs(0-fr):cg=Abs(d/2-fg):cb=Abs(d-fb):c=fn+400
	If Abs(0-fr)<=cr+thresh And Abs(0-fg)<=cg+thresh And Abs(d-fb)<=cb+thresh Then 				cr=Abs(0-fr):cg=Abs(0-fg):cb=Abs(d-fb):c=fn+500
	If Abs((d/2)-fr)<=cr+thresh And Abs(0-fg)<=cg+thresh And Abs((d)-fb)<=cb+thresh Then 		cr=Abs((d/2)-fr):cg=Abs(0-fg):cb=Abs(d-fb):c=fn+600
	If Abs(d-fr)<=cr+thresh And Abs(0-fg)<=cg+thresh And Abs((d/2)-fb)<=cb+thresh Then 			cr=Abs(d-fr):cg=Abs(0-fg):cb=Abs((d/2)-fb):c=fn+700
	If Abs((d/2)-fr)<=cr+thresh And Abs((d/2)-fg)<=cg+thresh And Abs((d/2)-fb)<=cb+thresh Then 	cr=Abs((d/2)-fr):cg=Abs((d/2)-fg):cb=Abs((d/2)-fb):c=fn+800
	If Abs(d-fr)<=cr+thresh And Abs((d)-fg)<=cg+thresh And Abs(d-fb)<=cb+thresh Then 			cr=Abs(d-fr):cg=Abs(d-fg):cb=Abs(d-fb):c=fn+900

cr=cr
cg=cg
cb=cb


Next

DebugLog c


Return c

End Function



Function Plot3D(meshin,fx#,fy#,fz#,brush,fr=-100,fg=-100,fb=-100)
fx=fx*2
fy=fy*2
fz=fz*2
box=CreateCube()
PositionMesh(box,fx+0.5,fy+0.5,fz+0.5)
ScaleMesh box,2,2,2
If fr>-100 Then brush=CreateBrush(fr,fg,fb)
PaintMesh box,brush
AddMesh box,meshin

FreeEntity box
End Function